package info.bukova.isspst.data;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

import org.hibernate.validator.constraints.Email;
import org.hibernate.validator.constraints.NotEmpty;
import org.hibernate.validator.constraints.URL;

@Entity
@Table(name="ADDRESS")
public class Address extends BaseData {
	
	@Column(name="COMPANY")
	private String company;
	@Column(name="DEPARTMENT")
	private String department;
	@Column(name="CONTACT_NAME")
	private String contactName;
	@Column(name="STREET")
	private String street;
	@Column(name="HOUSE_NUMBER")
	private String houseNumber;
	@Column(name="ZIP_CODE")
	private String zipCode;
	@Column(name="CITY")
	private String city;
	@Column(name="STATE")
	private String state;
	@Column(name="IC")
	private long ic;
	@Column(name="DIC")
	private String dic;
	@Column(name="PHONE")
	private String phone;
	@Column(name="EMAIL")
	private String email;
	@Column(name="WEB")
	private String web;
	@Column(name="DESCRIPTION")
	private String description;
	
	@NotNull(message = "Zadejte firmu")
	@NotEmpty(message = "Zadejte firmu")
	public String getCompany() {
		return company;
	}
	public void setCompany(String company) {
		this.company = company;
	}
	public String getDepartment() {
		return department;
	}
	public void setDepartment(String department) {
		this.department = department;
	}
	public String getContactName() {
		return contactName;
	}
	public void setContactName(String contactName) {
		this.contactName = contactName;
	}
	public String getStreet() {
		return street;
	}
	public void setStreet(String street) {
		this.street = street;
	}
	public String getHouseNumber() {
		return houseNumber;
	}
	public void setHouseNumber(String houseNumber) {
		this.houseNumber = houseNumber;
	}
	public String getZipCode() {
		return zipCode;
	}
	public void setZipCode(String zipCode) {
		this.zipCode = zipCode;
	}
	@NotNull(message = "Zadejte město")
	@NotEmpty(message = "Zadejte město")
	public String getCity() {
		return city;
	}
	public void setCity(String city) {
		this.city = city;
	}
	public String getState() {
		return state;
	}
	public void setState(String state) {
		this.state = state;
	}
	public long getIc() {
		return ic;
	}
	public void setIc(long ic) {
		this.ic = ic;
	}
	public String getDic() {
		return dic;
	}
	public void setDic(String dic) {
		this.dic = dic;
	}
	public String getPhone() {
		return phone;
	}
	public void setPhone(String phone) {
		this.phone = phone;
	}
	@Email(message = "Špatný formát adresy")
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	@URL(message = "Špatný formát adresy")
	public String getWeb() {
		return web;
	}
	public void setWeb(String web) {
		this.web = web;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
}
